import { DataLoaderPlugin } from 'unplugin-vue-router/data-loaders';
import { createGetRoutes, setupLayouts } from 'virtual:meta-layouts';
// import { createGetRoutes, setupLayouts } from 'virtual:generated-layouts';
import { createRouter, createWebHistory } from 'vue-router/auto';
import { handleHotUpdate, routes } from 'vue-router/auto-routes';

const router = createRouter({
  history: createWebHistory(import.meta.env.BASE_URL),
  routes: /* routes ?? */ setupLayouts(routes),
  strict: true,
  scrollBehavior: (_to, _from, savedPosition) => {
    if (savedPosition) {
      return savedPosition;
    } else {
      return { left: 0, top: 0 };
    }
  },
});
const getRoutes = createGetRoutes(router);
if (import.meta.hot) handleHotUpdate(router);
if ($__DEV__) Object.assign(window, { router });
router.onError((error) => {
  console.debug('🚨 [router error]: ', error);
});

export { getRoutes, router };
export function install({ app }: { app: import('vue').App<Element> }) {
  app
    // Register the plugin before the router
    .use(DataLoaderPlugin, { router })
    // adding the router will trigger the initial navigation
    .use(router);
  if ('2' === ('1' as never)) {
    const getRoutes = createGetRoutes(router);
    const setupLayoutsResult = setupLayouts(routes);

    console.debug(`routes :>> `, routes);
    console.debug(`getRoutes() :>> `, getRoutes()); // 获取路由表但是不包含布局路由
    console.debug(`setupLayoutsResult :>> `, setupLayoutsResult);
  }
}
// ========================================================================
// =========================== Router Guards ==============================
// ========================================================================
{
  // 警告：路由守卫的创建顺序会影响执行流程，请勿调整
  createNProgressGuard(router);
  createLogGuard(router);
  Object.assign(window, { stack: createStackGuard(router) });
}
